#!/bin/bash
#
# By -- WRQC343 -- gmrs-link.com
#
# Ver 1.6 - 8/2024 -
# ReConn install script - other networks

link="http://gmrs-link.com/rsync/reconn-other"

    echo ""
    echo "Creating Folders"
    
    mkdir /etc/asterisk/local/ReConn || exit 1

sleep 1    

    mkdir /etc/asterisk/local/ReConn/tpl || exit 1

sleep 1    

    mkdir /etc/asterisk/local/ReConn/Sound || exit 1
    
    echo "Folders - Complete"
    echo ""
    
    echo "Downloading Menu File"

    wget -P /usr/local/sbin/firsttime/ $link/ft9-ReConn.sh -q --show-progress || exit 1
    chmod 777 /usr/local/sbin/firsttime/ft9-ReConn.sh

    echo "Permissions Set"
    echo "Menu File - Complete"
    echo ""
    
    echo "Downloading ReConn Files"

    wget -P /etc/asterisk/local/ReConn/ $link/ReConn/ReConn.sh -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/ReConn.sh
       
    wget -P /etc/asterisk/local/ReConn/ $link/ReConn/ReConn-Enabled.sh -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/ReConn-Enabled.sh
    
    wget -P /etc/asterisk/local/ReConn/ $link/ReConn/ReConn-Disabled.sh -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/ReConn-Disabled.sh

    echo "Permissions Set"
    echo "ReConn Files - Complete"
    echo ""
    
    echo "Downloading Template Files"

    wget -P /etc/asterisk/local/ReConn/tpl/ $link/ReConn/tpl/ReConn.tpl -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/tpl/ReConn.tpl
    
    wget -P /etc/asterisk/local/ReConn/tpl/ $link/ReConn/tpl/ReConn-Enabled.tpl -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/tpl/ReConn-Enabled.tpl
    
    wget -P /etc/asterisk/local/ReConn/tpl/ $link/ReConn/tpl/ReConn-Disabled.tpl -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/tpl/ReConn-Disabled.tpl

    echo "Permissions Set"
    echo "Template Files - Complete"
    echo ""
    
    echo "Downloading Sound Files"

    wget -P /etc/asterisk/local/ReConn/Sound/ $link/ReConn/Sound/ReConn_Connecting.gsm -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/Sound/ReConn_Connecting.gsm
    
    wget -P /etc/asterisk/local/ReConn/Sound/ $link/ReConn/Sound/ReConn_ENABLED.gsm -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/Sound/ReConn_ENABLED.gsm
    
    wget -P /etc/asterisk/local/ReConn/Sound/ $link/ReConn/Sound/ReConn_DISABLED.gsm -q --show-progress || exit 1
    chmod 777 /etc/asterisk/local/ReConn/Sound/ReConn_DISABLED.gsm

    echo "Permissions Set"
    echo "Sound Files - Complete"
    echo ""
    
    echo "Backup Current Cron File"
    
    cp /var/spool/cron/root /var/spool/cron/root_`date +"%Y%m%d"`.bak
    
    echo "Cron Backup - Complete"
    echo ""
    
    echo "Checking Cron for existing entries"

    crontab -l | grep '/etc/asterisk/local/ReConn/ReConn.sh' 1>/dev/null 2>&1 
    (( $? == 0 )) && echo "Cron Error" && exit 

    echo "Cron Check - Complete"
    echo ""
 
    crontab -l >/tmp/crontab.tmp 
  
    echo "Adding Cron Strings"
    
    echo '*/10 * * * * /etc/asterisk/local/ReConn/ReConn.sh' >>/tmp/crontab.tmp 
  
    crontab /tmp/crontab.tmp 
  
    rm /tmp/crontab.tmp 
    
    echo "Cron File - Complete"
    echo ""

    echo Enter Node Number #?
    read var1
    echo ""
    echo -e "Enter ReConn Enable DTMF Code ( eg: 95 )#?"
    read var2 
    echo ""
    echo -e "Enter ReConn Disable DTMF Code ( eg: 96 )#?"
    read var3
    echo ""
    
    echo "Checking rpt.conf File for String Markers"

    grep '\;ReConn1' /etc/asterisk/rpt.conf >/dev/null 2>&1 
    grep '\;ReConn0' /etc/asterisk/rpt.conf >/dev/null 2>&1
    EXIT="$?"

 if [[ "$EXIT" == "0" ]]
  then
	  :

   elif [[ "$EXIT" == "1" ]]
    then
	 	    echo "No matches in rpt.conf file!"
        exit

  else
  	echo "rpt.conf encountered an Error: $EXIT."

fi

    echo "File Check - Complete"
    echo ""

    echo "Backup rpt.conf File"
    
    cp /etc/asterisk/rpt.conf /etc/asterisk/rpt.conf_`date +"%Y%m%d"`.bak
    
    echo "Backup - Complete" 
    echo ""
    
sleep 2
   
    echo "Adding rpt.conf Strings"
    
    sed -i 's|'\;ReConn1'|'$var2'=cmd,\/etc\/asterisk\/local\/ReConn\/ReConn-Enabled.sh|g' /etc/asterisk/rpt.conf
    sed -i 's|'\;ReConn0'|'$var3'=cmd,\/etc\/asterisk\/local\/ReConn\/ReConn-Disabled.sh|g' /etc/asterisk/rpt.conf 
    
    echo "Data Entry - Complete"
    echo ""

    echo "Backup controlpanel.ini File"
    
    cp /srv/http/supermon/controlpanel.ini /srv/http/supermon/controlpanel.ini_`date +"%Y%m%d"`.bak
    
    echo "Backup - Complete"
    echo ""
    
    echo "Adding controlpanel.ini strings"
    
    echo [$var1] >> /srv/http/supermon/controlpanel.ini
    echo labels[] = "ReConn Enable" >> /srv/http/supermon/controlpanel.ini
    echo cmds[] = "rpt fun $var1 *$var2" >> /srv/http/supermon/controlpanel.ini
    echo labels[] = "ReConn Disable" >> /srv/http/supermon/controlpanel.ini
    echo cmds[] = "rpt fun $var1 *$var3" >> /srv/http/supermon/controlpanel.ini
    
    echo "Data Entry - Complete"
    echo ""
 
sleep 2

    asterisk -rx "rpt reload"
   
    rm /root/ReConn-install-other.sh
    
    echo "RPT Reload - Complete"
    echo ""
    echo "ReConn Install - Complete" 

exit 0